package cn.com.infosec.jce.provider;

import cn.com.infosec.jce.exception.ExtCertPathValidatorException;
import cn.com.infosec.util.Selector;
import cn.com.infosec.x509.ExtendedPKIXParameters;
import cn.com.infosec.x509.X509AttributeCertStoreSelector;
import cn.com.infosec.x509.X509AttributeCertificate;
import java.security.InvalidAlgorithmParameterException;
import java.security.cert.CertPath;
import java.security.cert.CertPathParameters;
import java.security.cert.CertPathValidatorResult;
import java.security.cert.CertPathValidatorSpi;
import java.security.cert.X509Certificate;
import java.util.Date;
import java.util.List;

public class PKIXAttrCertPathValidatorSpi extends CertPathValidatorSpi {
   public CertPathValidatorResult engineValidate(CertPath certPath, CertPathParameters params) {
      if (params instanceof ExtendedPKIXParameters) {
         Selector var3;
         ExtendedPKIXParameters params1;
         if ((var3 = (params1 = (ExtendedPKIXParameters)params).getTargetConstraints()) instanceof X509AttributeCertStoreSelector) {
            X509AttributeCertificate var5;
            CertPath var10 = RFC3281CertPathUtilities.processAttrCert1(var5 = ((X509AttributeCertStoreSelector)var3).getAttributeCert(), params1);
            CertPathValidatorResult var10000 = RFC3281CertPathUtilities.processAttrCert2(certPath, params1);
            X509AttributeCertificate var10001 = var5;
            ExtendedPKIXParameters var10002 = params1;
            CertPath var10003 = certPath;
            ExtendedPKIXParameters var10004 = params1;
            X509AttributeCertificate var10005 = var5;
            X509AttributeCertificate var10007 = var5;
            X509AttributeCertificate var10011 = var5;
            X509Certificate var6;
            X509Certificate var10013 = var6 = (X509Certificate)certPath.getCertificates().get(0);
            RFC3281CertPathUtilities.processAttrCert3(var6, params1);
            RFC3281CertPathUtilities.processAttrCert4(var10013, params1);
            RFC3281CertPathUtilities.processAttrCert5(var10011, params1);
            RFC3281CertPathUtilities.processAttrCert7(var10007, certPath, var10, params1);
            RFC3281CertPathUtilities.additionalChecks(var10005, params1);

            Date var11;
            try {
               var11 = CertPathValidatorUtilities.getValidCertDateFromValidityModel(var10004, (CertPath)null, -1);
            } catch (AnnotatedException var4) {
               throw new ExtCertPathValidatorException("Could not get validity date from attribute certificate.", var4);
            }

            Date certPath1 = var11;
            List params2 = var10003.getCertificates();
            RFC3281CertPathUtilities.checkCRLs(var10001, var10002, var6, certPath1, params2);
            return var10000;
         } else {
            throw new InvalidAlgorithmParameterException("TargetConstraints must be an instance of " + X509AttributeCertStoreSelector.class.getName() + " for " + this.getClass().getName() + " class.");
         }
      } else {
         throw new InvalidAlgorithmParameterException("Parameters must be a " + ExtendedPKIXParameters.class.getName() + " instance.");
      }
   }
}
